
/***************************************************************************
  03 April 1996 10:11
  
  Copyright (c) 1996 Robert van de Geijn and The University of Texas at Austin.
  See the file GNU_LICENSE for details on the gnu license

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  Written by:   Many People including:

  Gregory A. Baker, Center for Space Research,
  University of Texas at Austin  78722      baker@csr.utexas.edu

  Philip A. Alpatov, Department of Physics,
  University of Texas at Austin 78712.     philip@physics.utexas.edu

  James Overfelt, Department of Mathematics,
  University of Texas at Austin  78712.    overfelt@@math.utexas.edu
  
  John Andrew Gunnels, Department of Computer Sciences,
  University of Texas at Austin 78712.     gunnels@@cs.utexas.edu
  
  Greg Morrow, Department of Physics, 
  University of Texas at Austin 78712.     morrow@@physics.utexas.edu
 
  Dr. Robert Van de Geijn, Department of Computer Sciences,
  University of Texas at Austin 78712.     rvdg@@cs.utexas.edu
 
***************************************************************************/



int  PLA_Gemm_front (char *transa, char *transb, double *alpha,
					PLA_Obj a,
					PLA_Obj b,
					double *beta,
					PLA_Obj c );

int  PLA_Gemm (int transa, int transb,   PLA_Obj alpha,
					PLA_Obj a,
					PLA_Obj b,
					PLA_Obj beta,
					PLA_Obj c );

int PLA_Gemm_notransa_notransb_1(int nb_alg, 
                                 int transa, 
                                 int transb,
                                 PLA_Obj alpha, 
                                 PLA_Obj a,
                                 PLA_Obj b, 
                                 PLA_Obj beta, 
                                 PLA_Obj c );

int PLA_Gemm_notransa_notransb_2(int nb_alg, 
                                 int transa, 
                                 int transb,
                                 PLA_Obj alpha, 
                                 PLA_Obj a,
                                 PLA_Obj b, 
                                 PLA_Obj beta, 
                                 PLA_Obj c );

int PLA_Gemm_notransa_notransb_3(int nb_alg, 
                                 int transa, 
                                 int transb,
                                 PLA_Obj alpha, 
                                 PLA_Obj a,
                                 PLA_Obj b, 
                                 PLA_Obj beta, 
                                 PLA_Obj c );

int PLA_Gemm_transa_transb_1( int nb_alg, 
                                 int transa, 
                                 int transb,
                              PLA_Obj alpha, 
                              PLA_Obj a, 
                              PLA_Obj b,
                              PLA_Obj beta, 
                              PLA_Obj c );

int PLA_Gemm_transa_transb_2( int nb_alg, 
                                 int transa, 
                                 int transb,
                              PLA_Obj alpha, 
                              PLA_Obj a, 
                              PLA_Obj b,
                              PLA_Obj beta, 
                              PLA_Obj c );

int PLA_Gemm_transa_transb_3( int nb_alg, 
                                 int transa, 
                                 int transb,
                              PLA_Obj alpha, 
                              PLA_Obj a, 
                              PLA_Obj b,
                              PLA_Obj beta, 
                              PLA_Obj c );

int PLA_Gemm_notransa_transb_1(int nb_alg, 
                                 int transa, 
                                 int transb,
                              PLA_Obj alpha, 
                              PLA_Obj a,
                              PLA_Obj b, 
                              PLA_Obj beta, 
                              PLA_Obj c );

int PLA_Gemm_notransa_transb_2(int nb_alg, 
                                 int transa, 
                                 int transb,
                              PLA_Obj alpha, 
                              PLA_Obj a,
                              PLA_Obj b, 
                              PLA_Obj beta, 
                              PLA_Obj c );

int PLA_Gemm_notransa_transb_3(int nb_alg, 
                                 int transa, 
                                 int transb,
                              PLA_Obj alpha, 
                              PLA_Obj a,
                              PLA_Obj b, 
                              PLA_Obj beta, 
                              PLA_Obj c );

int PLA_Gemm_transa_notransb_1(int nb_alg, 
                                 int transa, 
                                 int transb,
                              PLA_Obj alpha, 
                              PLA_Obj a,
                              PLA_Obj b, 
                              PLA_Obj beta, 
                              PLA_Obj c );

int PLA_Gemm_transa_notransb_2(int nb_alg, 
                                 int transa, 
                                 int transb,
                              PLA_Obj alpha, 
                              PLA_Obj a,
                              PLA_Obj b, 
                              PLA_Obj beta, 
                              PLA_Obj c );

int PLA_Gemm_transa_notransb_3(int nb_alg, 
                                 int transa, 
                                 int transb,
                              PLA_Obj alpha, 
                              PLA_Obj a,
                              PLA_Obj b, 
                              PLA_Obj beta, 
                              PLA_Obj c );


