/***************************************************************************
  03 April 1996 10:11
  
  Copyright (c) 1996 Robert van de Geijn and The University of Texas at Austin.
  See the file GNU_LICENSE for details on the gnu license

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  Written by:   Many People including:

  Gregory A. Baker, Center for Space Research,
  University of Texas at Austin  78722      baker@csr.utexas.edu

  Philip A. Alpatov, Department of Physics,
  University of Texas at Austin 78712.     philip@physics.utexas.edu

  James Overfelt, Department of Mathematics,
  University of Texas at Austin  78712.    overfelt@@math.utexas.edu
  
  John Andrew Gunnels, Department of Computer Sciences,
  University of Texas at Austin 78712.     gunnels@@cs.utexas.edu
  
  Greg Morrow, Department of Physics, 
  University of Texas at Austin 78712.     morrow@@physics.utexas.edu
 
  Dr. Robert Van de Geijn, Department of Computer Sciences,
  University of Texas at Austin 78712.     rvdg@@cs.utexas.edu
 
***************************************************************************/





int PLA_Pack_colpanel_mvector( PLA_Obj panel, PLA_Obj sendbuf,
			     int *sendcounts, int *displs);

int PLA_Copy_colmatrix_mvector( PLA_Obj matrix, PLA_Obj mvector);


int PLA_Pack_col_vector( PLA_Obj panel, PLA_Obj sendbuf,
			     int *sendcounts, int *displs);

int PLA_Copy_col_vector( PLA_Obj matrix, PLA_Obj vector);

int PLA_Pack_rowpanel_mvector( PLA_Obj panel, PLA_Obj sendbuf,
			      int *sendcounts, int *displs);

int PLA_Copy_rowmatrix_mvector( PLA_Obj matrix, PLA_Obj mvector);

int PLA_Pack_row_vector( PLA_Obj panel, PLA_Obj sendbuf,
		       int *sendcounts, int *displs);

int PLA_Copy_row_vector( PLA_Obj matrix, PLA_Obj vector);

int PLA_Pack_mvector_colmatrix(PLA_Obj mvector, PLA_Obj sendbuf, 
			     int *recvcounts, int *displs);

int PLA_Unpack_mvector_colmatrix( PLA_Obj recvbuf, int *recvcounts, int *displs,
				PLA_Obj panel);

int PLA_Copy_mvector_colmatrix( PLA_Obj mvector, PLA_Obj matrix);

int PLA_Pack_vector_col(PLA_Obj vector, PLA_Obj sendbuf, 
			     int *recvcounts, int *displs);

int PLA_Unpack_vector_col( PLA_Obj recvbuf, int *recvcounts, int *displs,
			 PLA_Obj panel);

int PLA_Copy_vector_col( PLA_Obj vector, PLA_Obj matrix);

int PLA_Pack_mvector_rowmatrix(PLA_Obj mvector, PLA_Obj sendbuf, 
			      int *recvcounts, int *displs);

int PLA_Unpack_mvector_rowmatrix( PLA_Obj recvbuf, int *recvcounts, int *displs,
				PLA_Obj panel);

int PLA_Copy_mvector_rowmatrix( PLA_Obj mvector, PLA_Obj matrix);

int PLA_Pack_vector_row(PLA_Obj vector, PLA_Obj sendbuf, 
			      int *recvcounts, int *displs);

int PLA_Unpack_vector_row( PLA_Obj recvbuf, int *recvcounts, int *displs,
				PLA_Obj panel);

int PLA_Copy_vector_row( PLA_Obj vector, PLA_Obj matrix);

int PLA_Copy_colmatrix_colpanel( PLA_Obj matrix, PLA_Obj panel);

int PLA_Copy_rowmatrix_rowpanel( PLA_Obj matrix, PLA_Obj panel);

int PLA_Copy_same_type( PLA_Obj source, PLA_Obj dest);

int PLA_Copy_rowmatrix_colmatrix( PLA_Obj source, PLA_Obj dest);

int PLA_Copy_colmatrix_rowmatrix( PLA_Obj source, PLA_Obj dest);

int PLA_Copy_check_parameters( PLA_Obj source, PLA_Obj dest, int *error);

int PLA_Copy( PLA_Obj source, PLA_Obj dest);


