PDIR		=	$(RTINSTdir)
STARTCODE	=	$(PDIR)/DYNINSTstartCode.o
ENDCODE		=	$(PDIR)/DYNINSTendCode.o
DYNLIB		=	$(PDIR)/libdyninstRT.o
DYNEXPORTS	=	$(PDIR)/DYNINST_EXPORTS

CC		=	cc
CFLAGS		=	-g
INCS		=	-I/usr/lpp/ppe.poe/include
LIBS		=	-lc -lg -lm

POELIBS         =       -L/usr/lpp/ppe.poe/lib -lppe -lmpi -lvtd \
			-L/usr/lpp/ppe.poe/lib/us -lmpci
CRT0		=	/usr/lpp/ppe.poe/lib/crt0.o

LINK		=	ld
LINKFLAGS	=	-bpT:0x10000000 -bpD:0x20000000 -btextro -bnodelcsect \
			-bnso -bI:/lib/syscalls.exp -bE:/usr/lib/libg.exp \
			-bnoobjreorder -H4 -bE:$(DYNEXPORTS) \
			-bI:/usr/lpp/ssp/css/libus/fs_ext.exp

OBJS		=	ns3d.o p3d.o dfft.o


ssNsmpif:	$(OBJS)
		$(LINK) $(LINKFLAGS) -o $@ $(CRT0) \
		$(STARTCODE) $(OBJS) $(ENDCODE) $(DYNLIB) $(LIBS) $(POELIBS)

.c.o:		
		$(CC) $(CFLAGS) $(INCS) -c $*.c -o $*.o

clean:		
		@-echo 'Making clean...'
		rm -f *.o
		rm -f ssNsmpif stats.out results.cc
		
